#include <stdlib.h>
#include <vcl.h>

#include "YRTMain.h"
#include "YRTUtils.h"

#pragma hdrstop

#pragma resource "*.dfm"

TYRTMainForm *YRTMainForm;

__fastcall TYRTMainForm::TYRTMainForm(TComponent* AOwner) : TForm(AOwner)
{
    Caption = title;
}

void __fastcall TYRTMainForm::FormCreate(TObject *ASender)
{
    ProgressLabel->Caption = "";
    TimeLabel->Caption = "";

    // Make sure that SceneImage is a bitmap:
    Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
    Bitmap->Width = SceneImage->Width;
    Bitmap->Height = SceneImage->Height;
    SceneImage->Picture->Assign(Bitmap);
    delete Bitmap;

    // Some examples use randomization to generate shapes:
    randomize();
}

void __fastcall TYRTMainForm::RenderButtonClick(TObject *ASender)
{
    Scene.GenerateExample_01Triangles(SceneImage->Width, SceneImage->Height);
    Engine.RenderScene(&Scene, SceneImage->Picture->Bitmap->Canvas, UpdateProgress);

    UpdateTime();
    ProgressLabel->Caption = "DONE";
    MessageBeep(MB_OK);
}

void TYRTMainForm::UpdateProgress(int Ax)
{
    ProgressLabel->Caption =
        "Progress: " +
        FloatToStrF((Ax * 1.0) / SceneImage->Width * 100, ffFixed, 1, 0) + "\%";
    UpdateTime();
    Application->ProcessMessages();
}

void TYRTMainForm::UpdateTime(void)
{
    TimeLabel->Caption =
        "Time: " +
        FormatDateTime("hh:nn:ss.zzz", Engine.GetRenderTime());
}

